<?php
/***************************************************************************
 *                                 quiz.php
 *                            -------------------
 *   copyright            : (C) 2002 by Saerdnaer
 *   email                : saerdnaer@web.de
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

if ( !defined('IN_PHPBB') )
{
	die("Hacking attempt");
}
if ( isset($quiz) )
{
	return;
}
class Quiz
{
	var $templates = array();
	var $config = array();
	var $quiz_data = array();
	var $quiz4_chars = array('a', 'b', 'c', 'd');
	var $bbcode_uid = '22da281c19';

	//
	// This function get the quiz config
	//
	function get_config($c_names = '')
	{
		global $db;
		static $no_c_names;
		if ( $no_c_names )
		{
			return true;
		}
		$where_sql = '';
		if ( !empty($c_names) )
		{
			if ( strpos($c_names, ',') )
			{
				$c_names = explode(',', $c_names);
				for ( $i = 0; $i < count($c_names); $i++ )
				{
					$c_names[$i] = trim($c_names[$i]);
					if ( empty($this->config[$c_names[$i]]) )
					{
						$where_sql .= ( $where_sql == '' ) ? " WHERE config_name IN ('$c_names[$i]'" : ", '$c_names[$i]'";
					}
				}
				$where_sql .= !empty($where_sql) ? ')' : '';
			}
			else
			{
				if ( empty($this->config[$c_names]) )
				{
					$where_sql .= " WHERE config_name = '$c_names'";
				}
			}
			if ( empty($where_sql) )
			{
				return true;
			}
		}
		else
		{
			$no_c_names = true;
		}
		$sql = "SELECT * FROM " . QUIZ_CONFIG_TABLE . $where_sql;
		if ( $result = $db->sql_query($sql) )
		{
			while ( $row = $db->sql_fetchrow($result) )
			{
				$this->config[$row['config_name']] = $row['config_value'];
			}
		}
		else
		{
			message_die(GENERAL_ERROR, 'Could not query quiz_config information', '', __LINE__, __FILE__, $sql);;
		}
		return true;
	}
	//
	// This function check the quiz answer auth
	//
	function check_answer_auth($topic_id, &$userdata)
	{
		global $db;
		if ( isset($userdata['quiz_answer_auth_' . $topic_id]) )
		{
			return $userdata['quiz_answer_auth_' . $topic_id];
		}
		if ( !$userdata['session_logged_in'] )
		{
			$userdata['quiz_answer_auth_' . $topic_id] = false;
			return false;
		}
		$this->get_config('allow_admin_in_quiz, allow_mod_in_quiz, allow_quiz_from_user_in_quiz, banned_users, banned_groups');
		if ( $userdata['user_level'] > USER )
		{
			if ( $userdata['user_level'] == ADMIN )
			{
				if ( !$this->config['allow_admin_in_quiz'] )
				{
					$userdata['quiz_answer_auth_' . $topic_id] = false;
					return false;
				}
			}
			else
			{
				if ( !$this->config['allow_mod_in_quiz'] )
				{
					$userdata['quiz_answer_auth_' . $topic_id] = false;
					return false;
				}
			}
		}
		if ( !$this->config['allow_quiz_from_user_in_quiz'] )
		{
			if ( empty($this->quiz_data) )
			{
				$this->get_quiz_data($topic_id);
			}
			if ( $userdata['user_id'] == $this->quiz_data['quiz_from_user_id'] )
			{
				$userdata['quiz_answer_auth_' . $topic_id] = false;
				return false;
			}
		}
		if ( !empty($this->config['banned_users']) )
		{
			if ( strpos(' ,' . $this->config['banned_users'] . ',', ',' . $user_id . ',') )
			{
				$userdata['quiz_answer_auth_' . $topic_id] = false;
				return false;
			}
		}
		$sql = "SELECT count(*) AS num
			FROM " . QUIZ_ANSWER_TABLE . "
			WHERE topic_id = '$topic_id'
				AND user_id = '" . $userdata['user_id'] . "'";
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not select user answer data', '', __LINE__, __FILE__, $sql);
		}
		$row = $db->sql_fetchrow($result);
		if ( $row['num'] > 0 )
		{
			$userdata['quiz_answer_auth_' . $topic_id] = false;
			return false;
		}
		if ( !empty($this->config['banned_groups']) )
		{
			$sql = "SELECT count(*) AS num FROM " . USER_GROUP_TABLE . " WHERE user_id = '" . $userdata['user_id'] . "' AND group_id IN(" . $this->config['banned_groups'] . ")";
			if ( !($result = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Could not select user group infos', '', __LINE__, __FILE__, $sql);
			}
			$row = $db->sql_fetchrow($result);
			if ( $row['num'] > 0 )
			{
				$userdata['quiz_answer_auth_' . $topic_id] = false;
				return false;
			}
		}
		$sql = "SELECT count(*) AS num
			FROM " . POSTS_TABLE . " p, " . POSTS_TEXT_TABLE . " pt
			WHERE p.topic_id = '$topic_id'
				AND p.poster_id = '" . $userdata['user_id'] . "'
				AND pt.post_id = p.post_id
				AND pt.quiz_answer <> ''";
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not select post count', '', __LINE__, __FILE__, $sql);
		}
		$row = $db->sql_fetchrow($result);
		if ( $row['num'] > 0 )
		{
			$userdata['quiz_answer_auth_' . $topic_id] = false;
			return false;
		}
		
		$userdata['quiz_answer_auth_' . $topic_id] = true;
		return true;
	}

	//
	// This function generate the quiz answer box
	//
	function generate_answer_box($topic_id, $user_id, $value)
	{
		global $db;
		$sql = "SELECT quiz_type, answer, answer2, answer3, answer4
			FROM " . QUIZ_TABLE . "
			WHERE quiz_topic_id = '$topic_id'";
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not select quiz', '', __LINE__, __FILE__, $sql);
		}
		if ( !($row = $db->sql_fetchrow($result)) )
		{
			message_die(GENERAL_ERROR, 'Quiz question doesn\' t exist.');
		}
		if ( $row['quiz_type'] > 0 )
		{
			$return = '<select tabindex="4" name="answer">';
			$return .= '<option value="">-</option>';
			for ($i = 1; $i <= 4; $i++)
			{
				$answer = $row['answer' . ( $i == 1 ? '' : $i )];
				$answer = preg_replace('#\[img:' . $this->bbcode_uid . '\].*?\[\/img:' . $this->bbcode_uid . '\]#', ' ', $answer); 
				$answer = preg_replace('#\[\/?url(=.*?)?\]#', ' ', $answer);
				$answer = preg_replace('#\[\/?[a-z\*=\+\-]+(\:?[0-9a-z]+)?:' . $this->bbcode_uid . '(\:[a-z0-9]+)?=?.*?\]#', ' ', $answer);
				$selected = ( $i == $value ) ? ' selected="selected"' : '';
				$return .='<option value="' . $i . '"' . $selected . '>' . $this->quiz4_chars[$i - 1] . ') ' . $answer . '</option>';
			}
			$return .= '</selected>';
			$js = 'if ( formErrors && document.post.answer.selectedIndex > 0 ) formErrors = false;';

		}
		else
		{
			$return = '<input type="text" name="answer" tabindex="4" value="' . $value . '" size="25" maxlenght="100" />';
			$js = 'if ( formErrors && document.post.answer.value.length != 0 ) formErrors = false;';
		}
		return array($return, $js);
	}

	//
	// This function assign vars to the {xxx} in $text
	//
	function assign_vars(&$text, $vars_array, $not_clean = '' )
	{
		while( list($match, $replace) = each($vars_array) )
		{
			$text = str_replace('{' . $match . '}', $replace, $text);
		}
		if ( empty($not_clean) ) 
		{
			$text = preg_replace('#{[^\s]*}#is', '', $text);
		}
		return $text;
	}

	//
	// This function check the truth of the answer ;-)
	//
	function check_answer($topic_id, $answer)
	{
		global $db;
		$sql = "SELECT quiz_type, answer, answer2, answer3, answer4
			FROM " . QUIZ_TABLE . "
			WHERE quiz_topic_id = '$topic_id'";
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not select quiz data', '', __LINE__, __FILE__, $sql);
		}
		if ( !($row = $db->sql_fetchrow($result)) )
		{
			message_die(GENERAL_ERROR, 'Quiz question doesn\' t exist.');
		}
		if ( $row['quiz_type'] > 0 )
		{
			if ( $answer == $row['quiz_type'] )
			{
				return true;
			}
		}
		else 
		{
			$answer = str_replace('', 'ue', str_replace('', 'ae', str_replace('', 'oe', strtolower(trim($answer)))));
			if ( $row['answer4'] == 'no' && !empty($row['answer']) && ( !empty($row['answer2']) || !empty($row['answer3']) ) )
			{
				$start_i = 1;
				$end_i = 3;
			}
			else
			{
				$start_i = 0;
				$end_i = 4;
			}
			for ( $i = $start_i; $i < $end_i; $i++ )
			{
				$a = 'answer' . ( ( $i > 0 ) ? ( $i + 1 ) : '' );
				if ( !empty($row[$a]) )
				{
					$mode = substr($row[$a], 0, 6);
					if ( $mode != 'RegEx:' )
					{
						$match = array("#\[.*?:$bbcode_uid:?.*?\]#si", '#\[url\]|\[\/url\]#si', '##is', '##is', '##is');
						$replace = array('', '', 'ae', 'oe', 'ue');
						$row[$a] = preg_replace($match, $replace, strip_tags($row[$a]));
					}
					$no_regex = false;
					switch ( $mode )
					{
						case 'RegEx:':
							break;
						case 'order:':
							$row[$a] = phpbb_preg_quote($row[$a], '#');
							$row[$a] = str_replace(' ', '.*?', '#' . $row[$a] . '#is');
							break;
						case 'onlyw:':
							$row[$a] = phpbb_preg_quote($row[$a], '#');
							$row[$a] = str_replace(' ', ')|(', '#^[(' . $row[$a] . ')]$#is');
							break;
						case 'samea:':
							$row[$a] = phpbb_preg_quote($row[$a], '#');
							$row[$a] = '#^' . $row[$a] . '$#is';
							break;
						case 'sameb:':
							$row[$a] = phpbb_preg_quote($row[$a], '#');
							$row[$a] = '#' . $row[$a] . '#is';
							break;
						default:
							$no_regex = true;
							break;
					}
					if ( $no_regex )
					{
						if ( !isset($answer_array) )
						{
							$answer_array = array();
							$answer = ' ' . $answer;
							$old_pos = 1;
							while ( ($pos = strpos($answer, ' ', $old_pos)) )
							{
								$word = substr($answer, $old_pos, $pos - $old_pos);
								$old_pos = $pos + 1;
								$answer_array[strtolower($word)] = true;
							}
							$word = substr($answer, $old_pos);
							$answer_array[$word] = true;
						}
						$a_str = ' ' . trim($row[$a]);
						$old_pos = 1;
						$ok = false;
						while ( ($pos = strpos($a_str, ' ', $old_pos)) )
						{
							$word = substr($a_str, $old_pos, $pos - $old_pos);
							if ( !isset($answer_array[strtolower($word)]) )
							{
								$ok = false;
								break;
							}
							$old_pos = $pos + 1;
							$ok = true;
						}
						if ( ( !$ok && $old_pos != 1 ) || !isset($answer_array[strtolower(substr($a_str, $old_pos))]) )
						{
							continue;
						}
						return true;
					}
					else
					{
						$answer = substr($row[$a], 6);
						if ( preg_match($row[$a], $answer) )
						{
							return true;
						}
					}
				}
			}
		}
		return false;
	}

	//
	// This function generate and set the next quiz time
	//
	function set_next_quiz_time()
	{
		global $db;
		$this->get_config('next_quiz, next_quiz_step, next_quiz_step_mode');
		switch ( $this->config['next_quiz_step_mode'] )
		{
			case 0: // hour
				$t = 3600;
				break;
			case 1: // day
				$t = 86400;
				break;
			case 2: // week
				$t = 604800;
				break;
			case 3: // month
				$t = date('G, i, s, n + ' . $this->config['next_quiz_step'] . ', d, Y', $this->config['next_quiz']);
				break;
			case 4: // year
				$t = date('G, i, s, n, d, Y + ' . $this->config['next_quiz_step'], $this->config['next_quiz']);
				break;
			default:
				$this->notify_admin('Could not set next quiz time because it is a error in step mode');
				return false;
		}
		if ( $this->config['next_quiz_step_mode'] > 2 )
		{
			eval ('$next_quiz = mktime(' . $t . ');');
		}
		else
		{
			$next_quiz = $this->config['next_quiz'] + round( $t * $this->config['next_quiz_step'] );
		}
		$sql = "UPDATE " . QUIZ_CONFIG_TABLE . "
			SET config_value = '$next_quiz'
			WHERE config_name = 'next_quiz'";
		if ( !$db->sql_query($sql) )
		{
			$this->notify_admin('Could not update next_quiz time', __LINE__, __FILE__, $sql);
			return false;
		}
		return $next_quiz;
	}
	//
	// This function set the laststart time
	//
	function set_last_start_time()
	{
		global $db;
		$sql = "UPDATE " . QUIZ_CONFIG_TABLE . "
			SET config_value = '" . time() . "'
			WHERE config_name = 'last_start_time'";
		if ( !$db->sql_query($sql) )
		{
			$this->notify_admin('Could not update last_start_time', __LINE__, __FILE__, $sql);
			return false;
		}
		return true;
	}

	//
	// This function post a message with the quizbot
	//
	function make_post($subject, $message, $mode, $topic_id = 0, $post_id = 0)
	{
		global $db, $phpbb_root_path, $phpEx, $userdata;
		global $html_entities_match, $html_entities_replace, $code_entities_match, $code_entities_replace;
		
		include($phpbb_root_path . 'includes/bbcode.'.$phpEx);
		include($phpbb_root_path . 'includes/functions_post.'.$phpEx);

		if ( isset($userdata) )
		{
			$userdata2 = $userdata;
		}
		$quiz_data = array();
		$userdata = get_userdata( intval($this->config['quizbot_id']) );
		$forum_id = $this->config['forum_id'];
		$html_on = $this->config['html'];
		$bbcode_on = $this->config['bbcode'];
		$smilies_on = $this->config['smilies'];
		$attach_sig = 0;
		$post_data['first_post'] = ( $mode == 'newtopic' ) ? true : false;
		$post_data['last_post'] = false;
		$post_data['has_poll'] = false;
		$post_data['edit_poll'] = false;
		$post_data['topic_quiz'] = ( $mode == 'newtopic' ) ? true : false;
		$post_data['flood_control_off'] = true;
		$return_message = '';
		$return_meta = '';
		$username = '';
		$poll_title = '';
		$poll_options = '';
		$poll_length = '';
		$bbcode_uid = '';
		$topic_type = POST_NORMAL;

		$cont_title = ( !empty($_POST['cont_title']) ) ? $_POST['cont_title'] : '';
		$cont_desc = ( !empty($_POST['cont_desc']) ) ? $_POST['cont_desc'] : '';
		$cont_number = ( !empty($_POST['number_cont']) ) ? $_POST['number_cont'] : 0;
		$cont_album_id = ( !empty($_POST['cont_album_id']) ) ? $_POST['cont_album_id'] : 0;
		$contest_date_day = ( !empty($_POST['contest_date_day']) ) ? $_POST['contest_date_day'] : 0;
		$contest_date_hou = ( !empty($_POST['contest_date_hou']) ) ? $_POST['contest_date_hou'] : 0;
		$contest_date_min = ( !empty($_POST['contest_date_min']) ) ? $_POST['contest_date_min'] : 0;
		$cont_date = ($contest_date_day * 86400) + ($contest_date_hou * 3600) + ($contest_date_min * 60);
		$cont_pic_db = ( !empty($_POST['cont_pic_db']) ) ? $_POST['cont_pic_db'] : 0;
		$cont_activation = ( !empty($_POST['cont_activation']) ) ? 1 : 0;
		$cont_app_day = ( !empty($_POST['contest_app_day']) ) ? $_POST['contest_app_day'] : 0;
		$cont_app_hou = ( !empty($_POST['contest_app_hou']) ) ? $_POST['contest_app_hou'] : 0;
		$cont_app_min = ( !empty($_POST['contest_app_min']) ) ? $_POST['contest_app_min'] : 0;

		$cont_app  = ($cont_app_day * 86400) + ($cont_app_hou * 3600) + ($cont_app_min * 60);

		$cont_delete = ( !empty($_POST['cont_delete']) ) ? 1 : 0;

		$topic_calendar_time = ( $topic_calendar_time != $post_data['topic_calendar_time'] && !$is_auth['auth_cal']) ? $post_data['topic_calendar_time'] : $topic_calendar_time;
		if (empty($topic_calendar_time)) $topic_calendar_time = 0;
		$topic_calendar_duration = ( $topic_calendar_duration != $post_data['topic_calendar_duration'] && !$is_auth['auth_cal']) ? $post_data['topic_calendar_duration'] : $topic_calendar_duration;
		if ( !empty($topic_calendar_duration) )
		{
			$topic_calendar_duration--;
		}
		if (empty($topic_calendar_time) || empty($topic_calendar_duration)) $topic_calendar_duration = 0;

		prepare_post($mode, $post_data, $bbcode_on, $html_on, $smilies_on, $error_msg, $username, $bbcode_uid, $subject, $message, $poll_title, $poll_options, $poll_length, $topic_calendar_time, $topic_calendar_duration, $cont_title, $cont_desc, $cont_number, $cont_album_id, $cont_date, $cont_app, $cont_pic_db, $cont_activation);
		if ( $error_msg != '' )
		{
			$this->notify_admin('Quiz Bot error while make_post():<br/>' . $error_msg);
			return false;
		}
		submit_post($mode, $post_data, $return_message, $return_meta, $forum_id, $topic_id, $post_id, $poll_id, $topic_type, $bbcode_on, $html_on, $smilies_on, $attach_sig, $bbcode_uid, str_replace("\'", "''", $username), str_replace("\'", "''", $subject), str_replace("\'", "''", $message), str_replace("\'", "''", $poll_title), $poll_options, $poll_length, $topic_calendar_time, $topic_calendar_duration, $cont_title, $cont_desc, $cont_number, $cont_album_id, $cont_date, $cont_app, $cont_pic_db, $cont_delete, $cont_activation);
		if ( $error_msg != '' )
		{
			$this->notify_admin('Quiz Bot error while make_post():<br/>' . $error_msg);
			return false;
		}
		if ( $mode != 'editpost' )
		{
			update_post_stats($mode, $post_data, $forum_id, $topic_id, $post_id, $userdata['user_id']);
		}
		if ( isset($userdata2) )
		{
			$userdata = $userdata2;
			unset($userdata2);
		}
		return true;
	}
	function make_answer_post ($topic_id, $user_id, $username, $post_id = false)
	{
		global $db, $phpEx;
		global $html_entities_match, $html_entities_replace, $code_entities_match, $code_entities_replace;

		if ( !$this->get_config() )
		{
			return false;
		}
		$subject = $this->config['subject2'];
		$message = $this->config['message2'];
		$this->get_quiz_data($topic_id);
		$this->assign_vars($message, array(
			'U_USERNAME' => "profile.$phpEx?mode=viewprofile&" . POST_USERS_URL . "=$user_id",
			'USERNAME' => $username,
			'QUESTION' => $this->quiz_data['question'],
			'ANSWER' => ( $this->quiz_data['quiz_type'] > 0 ) ? ( $this->quiz_data['answer' . (($this->quiz_data['quiz_type'] == 1) ? '' : $this->quiz_data['quiz_type'])] ) : $this->quiz_data['answer'])
		);

		$this->make_post($subject, $message, empty($post_id) ? 'reply' : 'editpost', $topic_id, &$post_id);

		$sql2 = empty($post_id) ? '' : ", quiz_bot_post_id = '$post_id'";
		$sql = "UPDATE " . QUIZ_TABLE . "
			SET quiz_status = 2, answered_by_user_id = '$user_id' $sql2
			WHERE quiz_topic_id = '$topic_id'";
		if ( !$db->sql_query($sql) )
		{
			$this->notify_admin('Could not update quiz question status', __LINE__, __FILE__, $sql);
			return false;
		}
		$sql = "DELETE FROM " . QUIZ_ANSWER_TABLE . "
			WHERE topic_id = '$topic_id'";
		if ( !$db->sql_query($sql) )
		{
			$this->notify_admin('Could not delete quiz answer table', __LINE__, __FILE__, $sql);
			return false;
		}
		$sql = "UPDATE " . TOPICS_TABLE . "
			SET topic_quiz = 2
			WHERE topic_id = '$topic_id'";
		if ( !$db->sql_query($sql) )
		{
			$this->notify_admin('Could not update topic quiz status', __LINE__, __FILE__, $sql);
			return false;
		}
		$sql = "UPDATE " . USERS_TABLE . "
			SET quiz_points = quiz_points + " . ( $this->config['quiz_points_disable'] ? 1 : $this->quiz_data['quiz_points'] ) . "
			WHERE user_id = $user_id";
		if ( !$db->sql_query($sql) )
		{
			$this->notify_admin('Could not update user quiz points', __LINE__, __FILE__, $sql);
			return false;
		}
		return true;
	}

	function make_disagree_answer_post ($topic_id, $post_id, $user_id, $username)
	{
		global $db, $phpEx;
		global $html_entities_match, $html_entities_replace, $code_entities_match, $code_entities_replace;
		$this->get_config();

		$subject = $this->config['subject3'];
		$message = $this->config['message3'];
		$this->get_quiz_data($topic_id);
		$this->assign_vars($message, array(
			'U_USERNAME' => "profile.$phpEx?mode=viewprofile&" . POST_USERS_URL . "=$user_id",
			'USERNAME' => $username,
			'QUESTION' => $this->quiz_data['question'],
			'ANSWER' => ( $this->quiz_data['quiz_type'] > 0 ) ? ( $this->quiz_data['answer' . (($this->quiz_data['quiz_type'] == 1) ? '' : $this->quiz_data['quiz_type'])] ) : $this->quiz_data['answer'])
		);

		$this->make_post($subject, $message, 'editpost', $topic_id, $post_id);

		$sql = "UPDATE " . QUIZ_TABLE . "
			SET quiz_status = 3, answered_by_user_id = 0
			WHERE quiz_topic_id = '$topic_id'";
		if ( !$db->sql_query($sql) )
		{
			$this->notify_admin('Could not update quiz question status', __LINE__, __FILE__, $sql);
			return false;
		}
		$sql = "UPDATE " . TOPICS_TABLE . "
			SET topic_quiz = 3
			WHERE topic_id = '$topic_id'";
		if ( !$db->sql_query($sql) )
		{
			$this->notify_admin('Could not update topic quiz status', __LINE__, __FILE__, $sql);
			return false;
		}
		$sql = "UPDATE " . USERS_TABLE . "
			SET quiz_points = quiz_points - " . ( $this->config['quiz_points_disable'] ? 1 : $this->quiz_data['quiz_points'] ) . "
			WHERE user_id = '$user_id'";
		if ( !$db->sql_query($sql) )
		{
			$this->notify_admin('Could not update user quiz points', __LINE__, __FILE__, $sql);
			return false;
		}
		$sql = "DELETE FROM " . QUIZ_ANSWER_TABLE . "
			WHERE topic_id = '$topic_id'";
		if ( !$db->sql_query($sql) )
		{
			$this->notify_admin('Could not delete quiz answer table', __LINE__, __FILE__, $sql);
			return false;
		}
		return true;
	}
	function make_question_post($quiz_id)
	{
		global $db,$html_entities_match, $html_entities_replace, $code_entities_match, $code_entities_replace;
		$this->get_config();
		
		if ( empty($quiz_id) )
		{
			return false;
		}

		$subject = $this->config['subject'];
		$message = $this->config['message'];
		$row['question'] = '';
		$row['username'] = '';
		$row['user_id'] = 0;
		if ( strpos(' ' . $subject, '{QUESTION}') || strpos(' ' . $message, '{QUESTION}') || strpos(' ' . $message, '{USERNAME}') )
		{
			$sql = "SELECT q.question, u.user_id, u.username
				FROM " . QUIZ_TABLE . " q
					LEFT JOIN " . USERS_TABLE . " u ON u.user_id = q.quiz_from_user_id
				WHERE q.quiz_id = '$quiz_id'";
			if ( !($result = $db->sql_query($sql)) )
			{
				$this->notify_admin("Could not get quiz question", __LINE__, __FILE__, $sql);
				return false;
			}
			$row = $db->sql_fetchrow($result);
		}
		$this->assign_vars($subject, array(
			'NUM' => $this->config['next_quiz_number'],
			'QUESTION' => $row['question'])
		);
		$this->assign_vars($message, array(
			'QUIZ' => '[QUIZ]',
			'NUM' => $this->config['next_quiz_number'],
			'QUESTION' => $row['question'],
			'U_USERNAME' => "profile.$phpEx?mode=viewprofile&" . POST_USERS_URL . "=" . $row['user_id'],
			'USERNAME' => $row['username'])
		);
		if ( ( $pos1 = strpos(' ' . $message, '<USERNAME>') ) && ( $pos2 = strpos(' ' . $message, '</USERNAME>') ) )
		{
			if ( empty($row['username']) )
			{
				$message = substr($message, 0, $pos1 - 1) . substr($message, $pos2 + 10);
			}
			else
			{
				$message = substr($message, 0, $pos1 - 1) . substr($message, $pos1 + 9, $pos2 - $pos1 - 10) . substr($message, $pos2 + 10);
			}
		}
		if ( !$this->make_post($subject, $message, 'newtopic', &$topic_id) )
		{
			$this->notify_admin('Could not make question post');
			return false;
		}
		$sql = "UPDATE " . QUIZ_TABLE . "
			SET quiz_status = 1, quiz_topic_id = '$topic_id'
			WHERE quiz_id = '$quiz_id'";
		if ( !$db->sql_query($sql) )
		{
			$this->notify_admin('Could not update quiz status', __LINE__, __FILE__, $sql);
			return false;
		}
		$sql = "UPDATE " . QUIZ_CONFIG_TABLE . "
			SET config_value = config_value + 1
			WHERE config_name = 'next_quiz_number'";
		if ( !$db->sql_query($sql) )
		{
			$this->notify_admin('Could not update next_quiz_number', __LINE__, __FILE__, $sql);
			return false;
		}
		return true;
	}
	function insert_answer_request($topic_id, $user_id)
	{
		global $db;
		$sql = "INSERT INTO " . QUIZ_ANSWER_TABLE . " (topic_id, user_id)
			VALUES ('$topic_id', '$user_id')";
		if ( !$db->sql_query($sql) )
		{
			$this->notify_admin("Could not insert answer request from user id $user_id for quiz in topic $topic_id", __LINE__, __FILE__, $sql);
			return false;
		}
		return true;
	}
	function get_random_quiz_id()
	{
		global $db, $lang;
		$this->get_config();

		$sql = "SELECT count(*) AS num
			FROM " . QUIZ_TABLE . "
			WHERE quiz_status = 0";

		if ( !($result = $db->sql_query($sql)) )
		{
			$this->notify_admin('Could not count quiz id', __LINE__, __FILE__, $sql);
			return false;
		}
		$row = $db->sql_fetchrow($result);
		if ( $row['num'] <= 1 )
		{
			$sql = "UPDATE " . QUIZ_CONFIG_TABLE . "
				SET config_value = 1
				WHERE config_name = 'disable'";

			if ( !$db->sql_query($sql) )
			{
				$this->notify_admin('Could not disable quiz', __LINE__, __FILE__, $sql);
				return false;
			}
			$this->notify_admin('quiz_disabled');
			if ( $row['num'] == 0 )
			{
				return false;
			}
		}
		$sql = "SELECT quiz_id
			FROM " . QUIZ_TABLE . "
			WHERE quiz_status = 0
			ORDER BY quiz_id ASC
			LIMIT ";
		if ( $row['num'] > 1 )
		{
			mt_srand( (double) microtime() * 1000000 );
			$random_quiz_id = mt_rand(1, $count_quiz_id);
			$sql .= ( $random_quiz_id - 1 ) . ', 1';
		}
		else
		{
			$sql .= '1';
		}
		if ( !($result = $db->sql_query($sql)) )
		{
			$this->notify_admin('Could not get random quiz id', __LINE__, __FILE__, $sql);
			return false;
		}
		$row = $db->sql_fetchrow($result);
		return $row['quiz_id'];
	}
	function load_template()
	{
		global $template;
		if ( !$file = file($template->make_filename('quiz.tpl')) )
		{
			message_die(GENERAL_ERROR, 'Could not read template file quiz.tpl');
		}
		$file = implode('', $file);
		$file = str_replace('\\', '\\\\', $file);
		$file = str_replace('\'', '\\\'', $file);
		$file = str_replace("\n", '', $file);
		$file = preg_replace('#<!-- BEGIN (.*?) -->(.*?)<!-- END (.*?) -->#', "\n" . '$this->templates[\'\\1\'] = \'\\2\';', $file);
		$this->templates = array();
		eval($file);
	}
	function get_template($name, $vars, $vars2 = '')
	{
		if ( empty($this->templates) )
		{
			$this->load_template();
		}
		$template = $this->templates[$name];
		if ( empty($template) )
		{
			message_die(GENERAL_ERROR, 'Could not get template');
		}
		$this->assign_vars($template, $vars, !empty($vars2));
		if ( !empty($vars2) ) 
		{
			$this->assign_vars($template, $vars2);
		}
		return $template;
	}
	function insert_block($mode, $message, $topic_id, $answer = '')
	{
		global $db, $lang, $userdata, $is_auth, $phpEx;
		$this->get_config('show_mod_answer_in_quiz, allow_admin_in_quiz, allow_mod_in_quiz, allow_quiz_from_user_in_quiz, banned_users, banned_groups');

		if ( empty($this->quiz_data) )
		{
			$this->get_quiz_data($topic_id);
		}
		if ( empty($this->quiz_data['parsed']) )
		{
			$this->parse_quiz_data();
		}
		if ( !isset($is_auth['auth_mod']) )
		{
			$is_auth['auth_mod'] = $this->check_mod_auth($userdata, true);
		}
		if ( $mode == QUIZ_QUESTION )
		{
			if ( empty($this->quiz_data) )
			{
				$block = '<div class="gen" align="center" style="color:red">' . $lang['Quiz_question_not_exist'] . '</div>';
			}
			else if ( $this->quiz_data['quiz_status'] >= 2 || ( $userdata['session_logged_in'] && $userdata['user_level'] > USER && ( $userdata['user_level'] == ADMIN || ( $this->config['show_mod_answer_in_quiz'] && $is_auth['auth_mod'] ) ) && !$this->check_answer_auth($topic_id, $userdata) ) )
			{
				if ( $this->quiz_data['quiz_type'] > 0 )
				{
					$template_name = 'quiz4_answered';
					$template_vars = array(
						'ANSWER' => $this->quiz4_chars['0'] . ') ' . $this->quiz_data['parsed']['answer'],
						'ANSWER2' => $this->quiz4_chars['1'] . ') ' . $this->quiz_data['parsed']['answer2'],
						'ANSWER3' => $this->quiz4_chars['2'] . ') ' . $this->quiz_data['parsed']['answer3'],
						'ANSWER4' => $this->quiz4_chars['3'] . ') ' . $this->quiz_data['parsed']['answer4'],

						'S_ANSWER' . ( ( $this->quiz_data['quiz_type'] == 1 ) ? '' : $this->quiz_data['quiz_type'] ) => 'checked="checked" '
					);
				}
				else
				{
					$template_name = 'quiz_answered';
					$template_vars = array(
						'ANSWER' => $this->quiz_data['parsed']['answer']
					);
				}
				if ( !empty($this->quiz_data['answer_explain']) )
				{
					$template_vars['ANSWER_EXPLAIN'] = $this->get_template('answer_explain', array(
						'L_ANSWER_EXPLAIN' => $lang['Answer_explain'],
						'ANSWER_EXPLAIN' => $this->quiz_data['parsed']['answer_explain'],
						'S_COLSPAN' => ( $this->quiz_data['quiz_type'] > 0 ? 2 : 1 ))
					);
				}
			}
			else
			{
				if ( empty($answer) && $userdata['session_logged_in'] && $this->check_answer_auth($topic_id, $userdata) )
				{
					if ( $this->quiz_data['quiz_type'] > 0 )
					{
						$template_name = 'quiz4';
						$template_vars = array(
							'ANSWER' => $this->quiz4_chars['0'] . ') ' . $this->quiz_data['parsed']['answer'],
							'ANSWER2' => $this->quiz4_chars['1'] . ') ' . $this->quiz_data['parsed']['answer2'],
							'ANSWER3' => $this->quiz4_chars['2'] . ') ' . $this->quiz_data['parsed']['answer3'],
							'ANSWER4' => $this->quiz4_chars['3'] . ') ' . $this->quiz_data['parsed']['answer4']
						);
					}
					else
					{
						$template_name = 'quiz';
						$template_vars = array();
					}
				}
				else
				{
					if ( $this->quiz_data['quiz_type'] > 0 )
					{
						$template_name = 'quiz4_question';
						$template_vars = array(
							'ANSWER' => $this->quiz4_chars['0'] . ') ' . $this->quiz_data['parsed']['answer'],
							'ANSWER2' => $this->quiz4_chars['1'] . ') ' . $this->quiz_data['parsed']['answer2'],
							'ANSWER3' => $this->quiz4_chars['2'] . ') ' . $this->quiz_data['parsed']['answer3'],
							'ANSWER4' => $this->quiz4_chars['3'] . ') ' . $this->quiz_data['parsed']['answer4']
						);
					}
					else
					{
						$template_name = 'quiz_question';
						$template_vars = array();
					}
				}
			}

			if ( !empty($template_name) )
			{
				$block = $this->get_template($template_name, $template_vars, array(
					'S_ACTION' => append_sid("posting.$phpEx?mode=reply&" . POST_TOPIC_URL . "=$topic_id"),

					'L_GO' => $lang['Go'],
					'L_QUESTION' => $lang['Question'],
					'L_ANSWER' => $lang['Answer'],

					'QUESTION' => $this->quiz_data['parsed']['question'])
				);
			}
			$replace = '[QUIZ]';
		}
		else
		{
			if ( empty($this->quiz_data) || $this->quiz_data['quiz_status'] >= 2 || $userdata['user_id'] == $answer['poster_id'] || ( $userdata['session_logged_in'] && $userdata['user_level'] > USER && ( $userdata['user_level'] == ADMIN || ( $this->config['show_mod_answer_in_quiz'] && $is_auth['auth_mod'] ) ) && !$this->check_answer_auth($topic_id, $userdata) ) )
			{
				if ( !empty($this->quiz_data) && $this->quiz_data['quiz_type'] > 0 )
				{
					$answer['quiz_answer'] = $this->quiz4_chars[$answer['quiz_answer'] - 1] . ') ' . $this->quiz_data['parsed']['answer' . ( ( $answer['quiz_answer'] == 1 ) ? '' : $answer['quiz_answer'])];
				}
				$block = $this->get_template('answer', array(
					'L_ANSWER' => $lang['Answer'],
					'ANSWER' => $answer['quiz_answer'])
				);
			}
			else
			{
				$block = $this->get_template('answer', array(
					'L_ANSWER' => $lang['Answer'],
					'ANSWER' => $lang['Quiz_answer_hidden'])
				);
			}
			$replace = '[ANSWER]';
		}
		if ( strpos(' ' . $message, $replace) )
		{
			$message = str_replace($replace, $block, $message);
		}
		else
		{
			$message .= ( empty($message) ? '' : '<br />' ) . $block;
		}
		return $message;
	}
	
	function get_quiz_data($topic_id)
	{
		global $db;
		$sql = "SELECT *
			FROM " . QUIZ_TABLE . "
			WHERE quiz_topic_id = '$topic_id'";
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Could not select quiz_data', '', __LINE__, __FILE__, $sql);
		}
		$this->quiz_data = $db->sql_fetchrow($result);
	}
	
	function parse_quiz_data()
	{
		global $userdata;
		$this->quiz_data['parsed']['question'] = bbencode_second_pass( $this->quiz_data['question'], $this->bbcode_uid);
		if ( $this->quiz_data['quiz_status'] > 1 || ( $userdata['user_level'] > USER && !$this->check_answer_auth($this->quiz_data['quiz_topic_id'], $userdata) ) )
		{
			if ( $this->quiz_data['quiz_type'] == 0 )
			{
				$this->quiz_data['parsed']['answer'] = bbencode_second_pass( $this->quiz_data['answer'], $this->bbcode_uid);
			}
			if ( !empty($this->quiz_data['answer_explain']) )
			{
				$this->quiz_data['parsed']['answer_explain'] = bbencode_second_pass( $this->quiz_data['answer_explain'], $this->bbcode_uid);
			}
		}
		if ( $this->quiz_data['quiz_type'] > 0 )
		{
			$this->quiz_data['parsed']['answer'] = bbencode_second_pass( $this->quiz_data['answer'], $this->bbcode_uid);
			$this->quiz_data['parsed']['answer2'] = bbencode_second_pass( $this->quiz_data['answer2'], $this->bbcode_uid);
			$this->quiz_data['parsed']['answer3'] = bbencode_second_pass( $this->quiz_data['answer3'], $this->bbcode_uid);
			$this->quiz_data['parsed']['answer4'] = bbencode_second_pass( $this->quiz_data['answer4'], $this->bbcode_uid);
		}
		
	}
	
	function send_pm_to_all_admins($subject, $message)
	{
		global $db;
		$sql = "SELECT user_id, user_notify_pm, user_email, user_lang, user_active
			FROM " . USERS_TABLE . "
			WHERE user_level = " . ADMIN;
		if ( !($result = $db->sql_query($sql)) )
		{
			return false;
		}
		while ( $to_userdata = $db->sql_fetchrow($result) )
		{
			$this->make_pm($subject, $message, $to_userdata);
		}
		return true;
	}
	function send_pm_to_user_id($user_id, $subject, $message, $eval_message = false)
	{
		global $db, $board_config;
		$sql = "SELECT user_id, user_notify_pm, user_email, user_lang, user_active
			FROM " . USERS_TABLE . "
			WHERE user_id = " . $user_id;
		if ( !($result = $db->sql_query($sql)) )
		{
			return false;
		}
		if ( $to_userdata = $db->sql_fetchrow($result) )
		{
			if ( $board_config['default_lang'] != $to_userdata['user_lang'] )
			{
				@include($phpbb_root_path . 'language/lang_' . $to_userdata['user_lang'] . '/lang_main.'.$phpEx);
				if ( !isset($lang) )
				{
					global $lang;
				}
			}
			else
			{
				global $lang;
			}
			if ( isset($lang[$subject]) )
			{
				$subject = $lang[$subject];
			}
			if ( $eval_message )
			{
				eval('$message = ' . $message);
			}
			else if ( isset($lang[$message]) )
			{
				$message = $lang[$message];
			}
			$this->make_pm($subject, $message, $to_userdata);
		}
		return true;
	}
	function make_pm($subject, $message, $to_userdata)
	{
		global $board_config, $db, $phpbb_root_path, $phpEx;
		global $html_entities_match, $html_entities_replace, $unhtml_specialchars_match, $unhtml_specialchars_replace;
		include($phpbb_root_path . 'includes/bbcode.'.$phpEx);
		include($phpbb_root_path . 'includes/functions_post.'.$phpEx);
		$this->get_config('quizbot_id');

		// a few settings
		$html_on = true;
		$bbcode_on = true;
		$smilies_on = true;

		if ( $bbcode_on )
		{
			$bbcode_uid = make_bbcode_uid();
		}
		$privmsg_subject = trim(strip_tags($subject));
		$privmsg_message = prepare_message($message, $html_on, $bbcode_on, $smilies_on, $bbcode_uid);
		$msg_time = time();

		$sql_info = "INSERT INTO " . PRIVMSGS_TABLE . " (privmsgs_type, privmsgs_subject, privmsgs_from_userid, privmsgs_to_userid, privmsgs_date, privmsgs_ip, privmsgs_enable_html, privmsgs_enable_bbcode, privmsgs_enable_smilies, privmsgs_attach_sig)
			VALUES (" . PRIVMSGS_NEW_MAIL . ", '" . str_replace("\'", "''", $privmsg_subject) . "', " . $this->config['quizbot_id'] . ", " . $to_userdata['user_id'] . ", $msg_time, '', $html_on, $bbcode_on, $smilies_on, 0)";

		if ( !($result = $db->sql_query($sql_info, BEGIN_TRANSACTION)) )
		{
			message_die(GENERAL_ERROR, 'Could not insert private message sent info.', '', __LINE__, __FILE__, $sql_info);
		}
		$privmsg_sent_id = $db->sql_nextid();
		$sql = "INSERT INTO " . PRIVMSGS_TEXT_TABLE . " (privmsgs_text_id, privmsgs_bbcode_uid, privmsgs_text)
			VALUES ($privmsg_sent_id, '" . $bbcode_uid . "', '" . addslashes($privmsg_message) . "')";

		if ( !$db->sql_query($sql, END_TRANSACTION) )
		{
			message_die(GENERAL_ERROR, 'Could not insert private message sent text.', '', __LINE__, __FILE__, $sql);
		}
		//
		// Add to the users new pm counter
		//
		$sql = "UPDATE " . USERS_TABLE . "
			SET user_new_privmsg = user_new_privmsg + 1, user_last_privmsg = " . time() . "
			WHERE user_id = " . $to_userdata['user_id'];
		if ( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, 'Could not update private message new/read status for user', '', __LINE__, __FILE__, $sql);
		}

		if ( $to_userdata['user_notify_pm'] && !empty($to_userdata['user_email']) && $to_userdata['user_active'] )
		{
			$script_name = preg_replace('/^\/?(.*?)\/?$/', "\\1", trim($board_config['script_path']));
			$script_name = ( $script_name != '' ) ? $script_name . '/privmsg.'.$phpEx : 'privmsg.'.$phpEx;
			$server_name = trim($board_config['server_name']);
			$server_protocol = ( $board_config['cookie_secure'] ) ? 'https://' : 'http://';
			$server_port = ( $board_config['server_port'] <> 80 ) ? ':' . trim($board_config['server_port']) . '/' : '/';

			include($phpbb_root_path . 'includes/emailer.'.$phpEx);
			$emailer = new emailer($board_config['smtp_delivery']);
			
			// For phpBB Versions >= 205
			$emailer->from($board_config['board_email']);
			$emailer->replyto($board_config['board_email']);

			// For phpBB Versions <= 204
			/*
			$email_headers = 'From: ' . $board_config['board_email'] . "\nReturn-Path: " . $board_config['board_email'] . "\r\n";
			$emailer->extra_headers($email_headers);
			*/

			$emailer->use_template('privmsg_notify', $to_userdata['user_lang']);
			$emailer->email_address($to_userdata['user_email']);
			$emailer->set_subject($lang['Notification_subject']);
					
			$emailer->assign_vars(array(
				'USERNAME' => $to_userdata['username'], 
				'SITENAME' => $board_config['sitename'],
				'EMAIL_SIG' => (!empty($board_config['board_email_sig'])) ? str_replace('<br />', "\n", "-- \n" . $board_config['board_email_sig']) : '', 

				'U_INBOX' => $server_protocol . $server_name . $server_port . $script_name . '?folder=inbox')
			);
			$emailer->send();
			$emailer->reset();
		}
		return true;
	}
	function check_mod_auth($userdata, $no_msg = false)
	{
		global $phpEx;
		if ( !$no_msg && !$userdata['session_logged_in'] )
		{
			$header_location = ( @preg_match('/Microsoft|WebSTAR|Xitami/', getenv('SERVER_SOFTWARE')) ) ? 'Refresh: 0; URL=' : 'Location: ';
			header($header_location . './' . append_sid("login.$phpEx?redirect=" . basename(__FILE__) ));
			exit;
		}
		else if ( $userdata['user_level'] == ADMIN )
		{
			return true;
		}
		else if ( $userdata['user_level'] > USER )
		{
			$this->get_config('forum_id');

			$is_auth = auth(AUTH_MOD, $this->config['forum_id'], $userdata);
			if ( $is_auth['auth_mod'] )
			{
				return true;
			}
		}
		if ( !$no_msg )
		{
			message_die(GENERAL_MESSAGE, $lang['Quiz_no_access']);
		}
		return false;
	}
	function notify_admin($msg_text = '', $err_line = '', $err_file = '', $sql_store = '')
	{
		global $board_config, $db, $phpbb_root_path, $phpEx;
		$error = defined('MANUAL_QUIZ');
		if ( !$error && !$this->get_config('admin_user_id, quizbot_id') )
		{
			$error = true;
		}
		if ( !$error && empty($this->config['admin_user_id'] ) )
		{
			$error = true;
		}
		if ( !$error )
		{
			$sql_error = $db->sql_error();
			$msg = '';
			if ( $sql_error['message'] != '' )
			{
				$msg .= "\n\n" . 'SQL Error : ' . $sql_error['code'] . ' ' . $sql_error['message'];
			}

			if ( $sql_store != '' )
			{
				$msg .= "\n\n" . $sql_store;
			}

			if ( $err_line != '' && $err_file != '' )
			{
			$msg .= "\n\n" . 'Line : ' . $err_line . "\n" . 'File : ' . $err_file;
			}
			$sql = "SELECT user_id, user_notify_pm, user_email, user_lang, user_active
				FROM " . USERS_TABLE . "
				WHERE user_id = '" . $this->config['admin_user_id'] . "'";
			if ( !($result = $db->sql_query($sql)) )
			{
				$error = true;
			}
			if ( !$error && !$to_userdata = $db->sql_fetchrow($result) )
			{
				$error = true;
			}
			if ( $board_config['default_lang'] != $to_userdata['user_lang'] )
			{
				@include($phpbb_root_path . 'language/lang_' . $to_userdata['user_lang'] . '/lang_main.'.$phpEx);
				if ( empty($lang) )
				{
					global $lang;
				}
			}
			else
			{
				global $lang;
				if ( empty($lang) )
				{
					@include($phpbb_root_path . 'language/lang_' . $to_userdata['user_lang'] . '/lang_main.'.$phpEx);
				}
			}
			if ( isset($lang[$msg_text]) )
			{
				$msg_text = $lang[$msg_text];
			}

			if ( !$error && !$this->make_pm('[Quizbot] ' . $lang['Error'], $msg_text . $msg, $to_userdata) )
			{
				$error = true;
			}
			if ( !$error )
			{
				return true;
			}
		}
		message_die(GENERAL_ERROR, $msg_text, '', $err_line, $err_file, $sql_store);
	}
}
$quiz = new Quiz;

// Constants
define('QUIZ_QUESTION', 0);
define('QUIZ_ANSWER', 1);
define('NEW_TOPIC', -1);

?>